%global srcname wxWidgets
%global wxbasename wxBase
%global gtk3dir bld_gtk3
%global sover 0

Name:           wxGTK
Version:        3.2.2.1
Release:        1%{?dist}
Summary:        GTK port of the wxWidgets GUI library
License:        wxWidgets
URL:            https://www.wxwidgets.org/
Source0:        https://github.com/%{srcname}/%{srcname}/releases/download/v%{version}/%{srcname}-%{version}.tar.bz2
Source1:       wx-config
Patch3000:         %{name}-3.1.6-abicheck.patch
Patch3001:         https://github.com/wxWidgets/wxWidgets/commit/9688ccc0874c0c513b73d01679b1b426f463477f.patch
Patch3002:         os-release.patch

BuildRequires: make, gcc-c++, gtk3-devel
BuildRequires:  webkit2gtk3-devel, zlib-devel, libpng-devel
BuildRequires:  libjpeg-devel, libtiff-devel, expat-devel
BuildRequires:  SDL2-devel, libGLU-devel, libSM-devel
BuildRequires:  gstreamer1-plugins-base-devel
BuildRequires:  gettext, cppunit-devel, libmspack-devel
BuildRequires:  doxygen, graphviz, libsecret-devel, libcurl-devel

Provides:       %{srcname} = %{version}-%{release}
Provides:       bundled(scintilla) = 3.7.2
Requires:       %{wxbasename}%{?_isa} = %{version}-%{release}
Requires:       %{name}-i18n = %{version}-%{release}

%description
wxWidgets is the GTK port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.


%package -n     %{wxbasename}-devel
Summary:        Development files for the wxBase3 library
Requires:       %{wxbasename} = %{version}-%{release}
Requires(post): /usr/sbin/update-alternatives
Requires(postun): /usr/sbin/update-alternatives

%description -n %{wxbasename}-devel
This package include files needed to link with the wxBase3 library.
wxWidgets is the GTK port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.


%package        devel
Summary:        Development files for the wxGTK library
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-gl = %{version}-%{release}
Requires:       %{name}-media = %{version}-%{release}
Requires:       %{name}-webview = %{version}-%{release}
Requires:       %{wxbasename} = %{version}-%{release}
Requires:       %{wxbasename}-devel = %{version}-%{release}
Requires:       gtk3-devel
Requires:       libGLU-devel
Provides:       %{srcname}-devel = %{version}-%{release}

%description devel
This package include files needed to link with the wxGTK library.
wxWidgets is the GTK port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.


%package        gl
Summary:        OpenGL add-on for the wxWidgets library
Requires:       %{name} = %{version}-%{release}

%description gl
OpenGL (a 3D graphics API) add-on for the wxWidgets library.
wxWidgets is the GTK port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.

%package        i18n
Summary:        i18n message catalogs for the wxWidgets library
BuildArch:      noarch

%description i18n
i18n message catalogs for the wxWidgets library.
wxWidgets is the GTK port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.

%package        media
Summary:        Multimedia add-on for the wxWidgets library
Requires:       %{name} = %{version}-%{release}

%description media
Multimedia add-on for the wxWidgets library.
wxWidgets is the GTK port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.

%package        webview
Summary:        WebView add-on for the wxWidgets library
Requires:       %{name} = %{version}-%{release}

%description webview
WebView add-on for the wxWidgets library.
wxWidgets is the GTK port of the C++ cross-platform wxWidgets
GUI library, offering classes for all common GUI controls as well as a
comprehensive set of helper classes for most common application tasks,
ranging from networking to HTML display and image manipulation.

%package -n     %{wxbasename}
Summary:        Non-GUI support classes from the wxWidgets library

%description -n %{wxbasename}
Every wxWidgets application must link against this library. It contains
mandatory classes that any wxWidgets code depends on (like wxString) and
portability classes that abstract differences between platforms. wxBase can
be used to develop console mode applications -- it does not require any GUI
libraries or the X Window System.

%package        docs
Summary:        Documentation for the wxGTK library
Requires:       %{name} = %{version}-%{release}
Provides:       %{srcname}-docs = %{version}-%{release}
BuildArch:      noarch

%description docs
This package provides documentation for the %{srcname} library.


%prep
%autosetup -n %{srcname}-%{version} -p1

sed -i -e 's|aclocal)|aclocal/wxwin32.m4)|' Makefile.in

sed -i -e 's|/usr/lib\b|%{_libdir}|' wx-config.in configure
sed -i -e 's|/lib|/%{_lib}|' src/unix/stdpaths.cpp

%build
%global _configure ../configure

mkdir %{gtk3dir}
pushd %{gtk3dir}
%configure \
  --with-gtk=3 \
  --with-opengl \
  --with-sdl \
  --with-libmspack \
  --enable-intl \
  --disable-rpath \
  --disable-glcanvasegl \
  --enable-ipv6

%make_build
popd

WX_SKIP_DOXYGEN_VERSION_CHECK=1 docs/doxygen/regen.sh html
mv docs/doxygen/out/html .

%install
pushd %{gtk3dir}
%make_install
popd

rm %{buildroot}%{_bindir}/wx-config
install -p -D -m 755 %{SOURCE1} %{buildroot}%{_libexecdir}/%{name}/wx-config
sed -i -e 's|=/usr|=%{_prefix}|' %{buildroot}%{_libexecdir}/%{name}/wx-config
ln -s ../..%{_libexecdir}/%{name}/wx-config %{buildroot}%{_bindir}/wx-config-3.2
touch %{buildroot}%{_bindir}/wx-config

mv %{buildroot}%{_bindir}/wxrc* %{buildroot}%{_libexecdir}/%{name}
ln -s ../..%{_libexecdir}/%{name}/wxrc-3.2 %{buildroot}%{_bindir}/wxrc-3.2
touch %{buildroot}%{_bindir}/wxrc

mkdir %{buildroot}%{_datadir}/bakefile/presets/wx32
mv %{buildroot}%{_datadir}/bakefile/presets/*.* %{buildroot}%{_datadir}/bakefile/presets/wx32

%find_lang wxstd-3.2

%post -n %{wxbasename}-devel
if [ -f %{_bindir}/wx-config ] && [ ! -h %{_bindir}/wx-config ] ; then
  rm %{_bindir}/wx-config
fi
/usr/sbin/update-alternatives --install %{_bindir}/wx-config \
  wx-config %{_libexecdir}/%{name}/wx-config 25
/usr/sbin/update-alternatives --install %{_bindir}/wxrc \
  wxrc %{_libexecdir}/%{name}/wxrc 25

%postun -n %{wxbasename}-devel
if [ $1 -eq 0 ] ; then
  /usr/sbin/update-alternatives --remove wx-config %{_libexecdir}/%{name}/wx-config
  /usr/sbin/update-alternatives --remove wxrc %{_libexecdir}/%{name}/wxrc
fi

%files
%license docs/gpl.txt docs/lgpl.txt docs/licence.txt docs/licendoc.txt docs/preamble.txt
%doc docs/changes.txt docs/readme.txt
%{_libdir}/libwx_gtk3u_adv-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_aui-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_core-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_html-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_propgrid-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_qa-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_ribbon-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_richtext-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_stc-*.so.%{sover}*
%{_libdir}/libwx_gtk3u_xrc-*.so.%{sover}*

%files -n %{wxbasename}-devel
%ghost %{_bindir}/wx-config
%ghost %{_bindir}/wxrc
%{_bindir}/wxrc-3.2
%{_bindir}/wx-config-3.2
%{_includedir}/wx-3.2
%{_libdir}/libwx_baseu*.so
%dir %{_libdir}/wx
%dir %{_libdir}/wx/config
%dir %{_libdir}/wx/include
%{_datadir}/aclocal/wxwin32.m4
%{_datadir}/bakefile/presets/wx32
%{_libexecdir}/%{name}

%files devel
%{_libdir}/libwx_gtk3u_*.so
%{_libdir}/wx/config/gtk3-unicode-3.2
%{_libdir}/wx/include/gtk3-unicode-3.2

%files gl
%{_libdir}/libwx_gtk3u_gl-*.so.%{sover}*

%files i18n -f wxstd-3.2.lang

%files media
%{_libdir}/libwx_gtk3u_media-*.so.%{sover}*

%files webview
%{_libdir}/libwx_gtk3u_webview-*.so.%{sover}*
%dir %{_libdir}/wx
%{_libdir}/wx/3.2

%files -n %{wxbasename}
%license docs/gpl.txt docs/lgpl.txt docs/licence.txt docs/licendoc.txt docs/preamble.txt
%doc docs/changes.txt docs/readme.txt
%{_libdir}/libwx_baseu-*.so.*
%{_libdir}/libwx_baseu_net-*.so.%{sover}*
%{_libdir}/libwx_baseu_xml-*.so.%{sover}*

%files docs
%doc html

%changelog
* Wed Dec 27 2023 Chair <chairou@tencent.com> - 3.2.2.1-1
- Init
